## GUN SHOOT
# AS AT ANCHORED EYES of shooting player
# Used for ALL guns

##getting gun stats
execute store result score gbg.current_ammo gbg.temp run data get entity @s SelectedItem.components.minecraft:custom_data.gbg_current_ammo
execute store result score gbg.max_ammo gbg.temp run data get entity @s SelectedItem.components.minecraft:custom_data.gbg_max_ammo
execute store result score gbg.damage gbg.temp run data get entity @s SelectedItem.components.minecraft:custom_data.gbg_damage
execute store result score gbg.range gbg.temp run data get entity @s SelectedItem.components.minecraft:custom_data.gbg_range
execute store result score gbg.fire_rate gbg.temp run data get entity @s SelectedItem.components.minecraft:custom_data.gbg_fire_rate

#stopping funciton if out of ammo
execute if score gbg.current_ammo gbg.temp matches ..0 unless score gbg.max_ammo gbg.temp matches 0 run return fail

## Playing Sound
data modify storage gbg:sounds sound set from entity @s SelectedItem.components.minecraft:custom_data.gbg_shoot_sound
function gbg:gun/shoot_sound with storage gbg:sounds

## Updating Description and Components
# lowering gun current ammo
scoreboard players remove gbg.current_ammo gbg.temp 1
# calculaitons for new "damage" (for the durability bar)
function gbg:misc/calculate_durability
# applying new damage and ammo components
data modify storage gbg:generic tag set value {}
execute store result storage gbg:generic tag.damage int 1 run scoreboard players get new_damage gbg.temp
execute store result storage gbg:generic tag.gbg_current_ammo int 1 run scoreboard players get gbg.current_ammo gbg.temp
# item modifiers
execute unless score gbg.max_ammo gbg.temp matches ..0 run function gbg:misc/set_durability with storage gbg:generic tag
execute unless score gbg.max_ammo gbg.temp matches ..0 run item modify entity @s weapon.mainhand gbg:gun/change_ammo
# calculating gun damage for explosive weapons
execute store result score gbg.damage_type gbg.temp run data get entity @s SelectedItem.components.minecraft:custom_data.gbg_damage_type
execute if score gbg.damage_type gbg.temp matches 2..3 run function gbg:misc/calculate_damage
# building lore
item modify entity @s weapon.mainhand gbg:remove_lore
execute unless score gbg.max_ammo gbg.temp matches ..0 run item modify entity @s weapon.mainhand gbg:gun/ammo
execute if score gbg.max_ammo gbg.temp matches ..0 run item modify entity @s weapon.mainhand gbg:gun/infinite_ammo
item modify entity @s weapon.mainhand gbg:gun/gun_damage
item modify entity @s weapon.mainhand gbg:gun/gun_range
item modify entity @s weapon.mainhand gbg:gun/fire_rate

## Setting Recoil
execute store result score gbg.recoil_strength gbg.temp run data get entity @s SelectedItem.components.minecraft:custom_data.gbg_recoil_strength
execute if score gbg.recoil_strength gbg.temp matches 1 run tp @s ~ ~ ~ ~ ~-0.7
execute if score gbg.recoil_strength gbg.temp matches 2 run tp @s ~ ~ ~ ~ ~-3
execute if score gbg.recoil_strength gbg.temp matches 3 run tp @s ~ ~ ~ ~ ~-5

## Shooting Projectile
#all the cute preliminary stuff
execute store result score gbg.damage gbg.temp run data get entity @s SelectedItem.components.minecraft:custom_data.gbg_damage
tag @s add gun_immune
scoreboard players operation @s gbg.cooldown = gbg.fire_rate gbg.temp
execute store result storage gbg:macro input.source int 1 run scoreboard players get @s gbg.id
execute store result storage gbg:macro input.damage int 1 run scoreboard players get gbg.damage gbg.temp
data modify storage gbg:macro input.gun_name set from entity @s SelectedItem.components.minecraft:custom_name
scoreboard players operation gbg.range gbg.temp *= 10 number
#running the right raycast
execute store result score gbg.projectile_type gbg.temp run data get entity @s SelectedItem.components.minecraft:custom_data.gbg_projectile_type
execute if score gbg.projectile_type gbg.temp matches 1 run function gbg:gun/projectile/bullet
execute if score gbg.projectile_type gbg.temp matches 2 run function gbg:gun/projectile/rocket
execute if score gbg.projectile_type gbg.temp matches 3 run function gbg:gun/projectile/fire
execute if score gbg.projectile_type gbg.temp matches 4 run function gbg:gun/projectile/blaze_fire
execute if score gbg.projectile_type gbg.temp matches 5 run function gbg:gun/projectile/laser
execute if score gbg.projectile_type gbg.temp matches 6 run function gbg:gun/projectile/large_laser
execute if score gbg.projectile_type gbg.temp matches 7 run function gbg:gun/projectile/green
execute if score gbg.projectile_type gbg.temp matches 8 run function gbg:gun/projectile/blue
execute if score gbg.projectile_type gbg.temp matches 9 run function gbg:gun/projectile/pink
execute if score gbg.projectile_type gbg.temp matches 10 run function gbg:gun/projectile/red
execute if score gbg.projectile_type gbg.temp matches 11 run function gbg:gun/projectile/light

## Shooting Additional Projectiles
#only does this if the fire rate = 1
execute if score gbg.fire_rate gbg.temp matches 1 unless score @s gbg.burst_duration matches 1.. run scoreboard players set @s gbg.burst_duration 4


