scoreboard players reset gbg.current_ammo_type gbg.temp
scoreboard players reset has_gbg.current_ammo gbg.temp
## GUN RELOAD
# AS AT the reloading player
# Used for ALL guns (except for the ammoless ones of course)

## Canceling if at max Ammo
execute store result score gbg.max_ammo gbg.temp run data get entity @s SelectedItem.components.minecraft:custom_data.gbg_max_ammo
execute store result score gbg.current_ammo gbg.temp run data get entity @s SelectedItem.components.minecraft:custom_data.gbg_current_ammo
execute if score gbg.current_ammo gbg.temp = gbg.max_ammo gbg.temp run return fail


## Removing Ammo from Inventory and Setting Cooldown
data modify storage gbg:ammo ammo_base set from entity @s SelectedItem.components.minecraft:custom_data.gbg_ammo_base
data modify storage gbg:ammo ammo_tag set from entity @s SelectedItem.components.minecraft:custom_data.gbg_ammo_item_tag
execute store result score has_ammo gbg.temp run function gbg:reload/take_ammo with storage gbg:ammo
execute if score has_ammo gbg.temp matches 1 run scoreboard players set @s gbg.cooldown 10
execute if score has_ammo gbg.temp matches 1 run return fail

execute store result score gbg.current_ammo_type gbg.temp run data get entity @s SelectedItem.components.minecraft:custom_data.gbg_current_ammo_type
execute store result score gbg.reload_speed gbg.temp run data get entity @s SelectedItem.components.minecraft:custom_data.gbg_reload_speed
scoreboard players operation @s gbg.cooldown = gbg.reload_speed gbg.temp
scoreboard players operation @s gbg.reloading_time = gbg.reload_speed gbg.temp

## Playing Sound
data modify storage gbg:sounds sound set from entity @s SelectedItem.components.minecraft:custom_data.gbg_reload_sound
function gbg:reload/reload_sound with storage gbg:sounds


## Updating Description and Tags
# getting gun stats
execute store result score gbg.damage gbg.temp run data get entity @s SelectedItem.components.minecraft:custom_data.gbg_damage
execute store result score gbg.range gbg.temp run data get entity @s SelectedItem.components.minecraft:custom_data.gbg_range
execute store result score gbg.fire_rate gbg.temp run data get entity @s SelectedItem.components.minecraft:custom_data.gbg_fire_rate
# updating ammo
execute store result score gun_reload_type gbg.temp run data get entity @s SelectedItem.components.minecraft:custom_data.gun_reload_type
execute if score gun_reload_type gbg.temp matches 1 run scoreboard players operation gbg.current_ammo gbg.temp = gbg.max_ammo gbg.temp
execute if score gun_reload_type gbg.temp matches 2 run scoreboard players add gbg.current_ammo gbg.temp 1
# updating durability visual
execute if score gun_reload_type gbg.temp matches 1 run scoreboard players set new_damage gbg.temp 0
execute if score gun_reload_type gbg.temp matches 2 run function gbg:misc/calculate_durability
# applying new damage and ammo tags
data modify storage gbg:generic tag set value {}
execute store result storage gbg:generic tag.damage int 1 run scoreboard players get new_damage gbg.temp
execute store result storage gbg:generic tag.gbg_current_ammo int 1 run scoreboard players get gbg.current_ammo gbg.temp
function gbg:misc/set_durability with storage gbg:generic tag
item modify entity @s weapon.mainhand gbg:gun/change_ammo
# calculating gun damage for explosive weapons
execute store result score gbg.damage_type gbg.temp run data get entity @s SelectedItem.components.minecraft:custom_data.gbg_damage_type
execute if score gbg.damage_type gbg.temp matches 2..3 run function gbg:misc/calculate_damage
# building lore
item modify entity @s weapon.mainhand gbg:remove_lore
item modify entity @s weapon.mainhand gbg:gun/ammo
item modify entity @s weapon.mainhand gbg:gun/gun_damage
item modify entity @s weapon.mainhand gbg:gun/gun_range
item modify entity @s weapon.mainhand gbg:gun/fire_rate


