## Player Looping Function
execute as @a at @s run function gbg:player_loop

## Equipment Specific Commands
#land mine specific commands
execute as @e[type=item_frame,tag=land_mine,sort=random] at @s if entity @e[type=!#gbg:land_mine_not_mob,dx=0] run function gbg:equipment/land_mine/explode

# Throwable Commands
scoreboard players set @e[scores={gbg.throwable_start=1},type=marker,tag=gbg_throwable_tracker] gbg.throwable_start 2
execute as @e[type=snowball,nbt={Item:{components:{"minecraft:custom_data":{gbg_throwable:1b}}}}] at @s run function gbg:equipment/throwables/loop
execute as @e[type=marker,tag=pipe_bomb_tracker,scores={gbg.throwable_start=2}] at @s unless entity @e[type=snowball,nbt={Item:{components:{"minecraft:custom_data":{pipe_bomb:1b}}}},distance=..1,limit=1,sort=nearest] run function gbg:equipment/throwables/pipe_bomb_impact
execute as @e[type=marker,tag=molotov_cocktail_tracker,scores={gbg.throwable_start=2}] at @s unless entity @e[type=snowball,nbt={Item:{components:{"minecraft:custom_data":{molotov_cocktail:1b}}}},distance=..1,limit=1,sort=nearest] run function gbg:equipment/throwables/molotov_cocktail_impact
execute as @e[type=marker,tag=grenade_tracker,scores={gbg.throwable_start=2}] at @s unless entity @e[type=snowball,nbt={Item:{components:{"minecraft:custom_data":{grenade:1b}}}},distance=..1,limit=1,sort=nearest] run function gbg:equipment/throwables/grenade_impact
execute as @e[type=marker,tag=chemical_grenade_tracker,scores={gbg.throwable_start=2}] at @s unless entity @e[type=snowball,nbt={Item:{components:{"minecraft:custom_data":{chemical_grenade:1b}}}},distance=..1,limit=1,sort=nearest] run function gbg:equipment/throwables/chemical_grenade_impact

# Turret Code
execute as @e[type=item_frame,tag=placer] at @s align xyz positioned ~0.5 ~ ~0.5 run function gbg:turret/placer
execute as @e[type=pig,tag=turret] at @s run function gbg:turret/loop

execute as @e[type=armor_stand,tag=auto,tag=!destroyed] at @s unless entity @e[type=pig,tag=turret,distance=..0.1,limit=1,sort=nearest] run function gbg:turret/auto/stages/destroyed
execute as @e[type=armor_stand,tag=sentry,tag=!destroyed] at @s unless entity @e[type=pig,tag=turret,distance=..0.1,limit=1,sort=nearest] run function gbg:turret/sentry/stages/destroyed
execute as @e[type=armor_stand,tag=perdition,tag=!destroyed] at @s unless entity @e[type=pig,tag=turret,distance=..0.1,limit=1,sort=nearest] run function gbg:turret/perdition/stages/destroyed

scoreboard players remove @e[scores={gbg.behind_cover=1..}] gbg.behind_cover 1

